diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c.c ocamlnet-4.1.9.patched/src/netsys/netsys_c.c
--- src/netsys/netsys_c.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c.c	2026-05-29 06:31:59
@@ -12,13 +12,13 @@
 #ifdef _WIN32
     switch (Descr_kind_val(fd)) {
     case KIND_HANDLE:
-	return copy_int64((intnat) (Handle_val(fd)));
+	return caml_copy_int64((intnat) (Handle_val(fd)));
     case KIND_SOCKET:
-	return copy_int64((intnat) (Socket_val(fd)));
+	return caml_copy_int64((intnat) (Socket_val(fd)));
     }
-    return copy_int64(0);
+    return caml_copy_int64(0);
 #else
-    return copy_int64(Long_val(fd));
+    return caml_copy_int64(Long_val(fd));
 #endif
 }
 
@@ -45,13 +45,13 @@
     win32_maperr(e);
     e = errno;
 #endif
-    return(unix_error_of_code(e));
+    return(caml_unix_error_of_code(e));
 }
 
 CAMLprim value netsys_get_nonblock(value fd)
 {
 #ifdef _WIN32
-    invalid_argument("Netsys_posix.get_nonblcok not avaiable");
+    caml_invalid_argument("Netsys_posix.get_nonblcok not avaiable");
 #else
     int r;
 
@@ -67,7 +67,7 @@
     _exit(Int_val(n));
     return Val_int(0);
 #else
-    invalid_argument("Netsys._exit not available");
+    caml_invalid_argument("Netsys._exit not available");
 #endif
 }
 
@@ -76,7 +76,7 @@
 #ifdef HAVE_SYSCONF
     return Val_long(sysconf(_SC_OPEN_MAX));
 #else
-    invalid_argument("Netsys.sysconf_open_max not available");
+    caml_invalid_argument("Netsys.sysconf_open_max not available");
 #endif
 }
 
@@ -89,7 +89,7 @@
     if (pgid == -1) uerror("getpgid", Nothing);
     return Val_int(pgid);
 #else
-    invalid_argument("Netsys.getpgid not available");
+    caml_invalid_argument("Netsys.getpgid not available");
 #endif
 }
 
@@ -102,7 +102,7 @@
     if (r == -1) uerror("setpgid", Nothing);
     return Val_int(0);
 #else
-    invalid_argument("Netsys.setpgid not available");
+    caml_invalid_argument("Netsys.setpgid not available");
 #endif
 }
 
@@ -115,7 +115,7 @@
     if (pgid == -1) uerror("tcgetpgrp", Nothing);
     return Val_int(pgid);
 #else
-    invalid_argument("Netsys.tcgetpgrp not available");
+    caml_invalid_argument("Netsys.tcgetpgrp not available");
 #endif
 }
 
@@ -128,7 +128,7 @@
     if (r == -1) uerror("tcsetpgrp", Nothing);
     return Val_int(0);
 #else
-    invalid_argument("Netsys.tcsetpgrp not available");
+    caml_invalid_argument("Netsys.tcsetpgrp not available");
 #endif
 }
 
@@ -137,10 +137,10 @@
 #ifdef HAVE_POSIX_TTY
     char *s;
     s = NULL;
-    return copy_string(ctermid(s));
+    return caml_copy_string(ctermid(s));
     /* ctermid is always successful; however it can return an empty string */
 #else
-    invalid_argument("Netsys.ctermid not available");
+    caml_invalid_argument("Netsys.ctermid not available");
 #endif
 }
 
@@ -151,9 +151,9 @@
 
     s = ttyname(Int_val(fd));
     if ( s == NULL ) uerror("ttyname", Nothing);
-    return copy_string(s);
+    return caml_copy_string(s);
 #else
-    invalid_argument("Netsys.ttyname not available");
+    caml_invalid_argument("Netsys.ttyname not available");
 #endif
 }
 
@@ -166,7 +166,7 @@
     if ( sid == -1 )  uerror("getsid", Nothing);
     return Val_int(sid);
 #else
-    invalid_argument("Netsys.getsid not available");
+    caml_invalid_argument("Netsys.getsid not available");
 #endif
 }
 
@@ -179,7 +179,7 @@
     if (r == -1) uerror("setreuid", Nothing);
     return Val_int(0);
 #else
-    invalid_argument("Netsys.setreuid not available");
+    caml_invalid_argument("Netsys.setreuid not available");
 #endif
 }
 
@@ -192,7 +192,7 @@
     if (r == -1) uerror("setregid", Nothing);
     return Val_int(0);
 #else
-    invalid_argument("Netsys.setregid not available");
+    caml_invalid_argument("Netsys.setregid not available");
 #endif
 }
 
@@ -210,7 +210,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.initgroups not available");
+    caml_invalid_argument("Netsys_posix.initgroups not available");
 #endif
 }
 
@@ -223,7 +223,7 @@
 	uerror("fsync", Nothing);
     return Val_unit;
 #else
-    invalid_argument("Netsys.fsync not available");
+    caml_invalid_argument("Netsys.fsync not available");
 #endif
 }
 
@@ -240,7 +240,7 @@
 	uerror("fdatasync", Nothing);
     return Val_unit;
 #else
-    invalid_argument("Netsys.fdatasync not available");
+    caml_invalid_argument("Netsys.fdatasync not available");
 #endif
 }
 
@@ -249,7 +249,7 @@
     if (fchdir(Int_val(fd)) == -1) uerror("fchdir", Nothing);
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.fchdir not available");
+    caml_invalid_argument("Netsys_posix.fchdir not available");
 #endif
 }
 
@@ -260,11 +260,11 @@
   value res;
   d = fdopendir(Int_val(fd));
   if (d == (DIR *) NULL) uerror("fdopendir", Nothing);
-  res = alloc_small(1, Abstract_tag);
+  res = caml_alloc_small(1, Abstract_tag);
   DIR_Val(res) = d;
   return res;
 #else
-  invalid_argument("Netsys_posix.fdopendir not available");
+  caml_invalid_argument("Netsys_posix.fdopendir not available");
 #endif
 }
 
@@ -281,12 +281,12 @@
 	uerror("realpath", Nothing);
     }
     else {
-	name_out = copy_string(name_out_s);
+	name_out = caml_copy_string(name_out_s);
 	free(name_out_s);
     }
     return name_out;
 #else
-    invalid_argument("Netsys_posix.realpath not available");
+    caml_invalid_argument("Netsys_posix.realpath not available");
 #endif
 }
 
@@ -299,7 +299,7 @@
     if ( e < 0 ) uerror("grantpt", Nothing);
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.granpt not available");
+    caml_invalid_argument("Netsys_posix.granpt not available");
 #endif
 }
 
@@ -312,7 +312,7 @@
     if ( e < 0 ) uerror("unlockpt", Nothing);
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.unlockpt not available");
+    caml_invalid_argument("Netsys_posix.unlockpt not available");
 #endif
 }
 
@@ -324,9 +324,9 @@
 
     s = ptsname(Int_val(fd));
     if ( s == NULL ) uerror("ptsname", Nothing);
-    return copy_string(s);
+    return caml_copy_string(s);
 #else
-    invalid_argument("Netsys_posix.ptsname not available");
+    caml_invalid_argument("Netsys_posix.ptsname not available");
 #endif
 }
 
@@ -348,7 +348,7 @@
     if (fd == -1) uerror("openpt", Nothing);
     return Val_int(fd);
 #else
-    invalid_argument("Netsys_posix.posix_openpt not available");
+    caml_invalid_argument("Netsys_posix.posix_openpt not available");
 #endif
 }
 
@@ -356,7 +356,7 @@
 CAMLprim value netsys_mknod (value name, value perm, value nt)
 {
 #ifdef _WIN32
-    invalid_argument("Netsys_posix.mknod not available");
+    caml_invalid_argument("Netsys_posix.mknod not available");
 #else
     mode_t m;
     dev_t d;
@@ -473,8 +473,8 @@
     char * p;
 
     /* shamelessly copied from ocaml distro */
-    cv_flags = convert_flag_list(flags, open_flag_table);
-    clo_flags = convert_flag_list(flags, open_cloexec_table);
+    cv_flags = caml_convert_flag_list(flags, open_flag_table);
+    clo_flags = caml_convert_flag_list(flags, open_cloexec_table);
     if (clo_flags & CLOEXEC)
         cloexec = 1;
     else if (clo_flags & KEEPEXEC)
@@ -484,12 +484,12 @@
 #if defined(O_CLOEXEC)
     if (cloexec) cv_flags |= O_CLOEXEC;
 #endif
-    p = stat_alloc(string_length(path) + 1);
+    p = caml_stat_alloc(caml_string_length(path) + 1);
     strcpy(p, String_val(path));
-    enter_blocking_section();
+    caml_enter_blocking_section();
     ret = openat(Int_val(dirfd), p, cv_flags, Int_val(perm));
-    leave_blocking_section();
-    stat_free(p);
+    caml_leave_blocking_section();
+    caml_stat_free(p);
     if (ret == -1) uerror("openat", path);
 #if !defined(O_CLOEXEC)
     {
@@ -500,7 +500,7 @@
 #endif
     CAMLreturn (Val_int(ret));
 #else
-    invalid_argument("Netsys_posix.openat not available");
+    caml_invalid_argument("Netsys_posix.openat not available");
 #endif
 }
 
@@ -517,15 +517,15 @@
 {
 #ifdef HAVE_AT
     int ret, cv_perms, cv_flags;
-    cv_perms = convert_flag_list(perms, access_permission_table);
-    cv_flags = convert_flag_list(flags, at_flags_table);
+    cv_perms = caml_convert_flag_list(perms, access_permission_table);
+    cv_flags = caml_convert_flag_list(flags, at_flags_table);
     cv_flags &= (AT_EACCESS | AT_SYMLINK_NOFOLLOW);
     ret = faccessat(Int_val(dirfd), String_val(path), cv_perms, cv_flags);
     if (ret == -1)
 	uerror("faccessat", path);
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.faccessat not available");
+    caml_invalid_argument("Netsys_posix.faccessat not available");
 #endif
 }
 
@@ -537,7 +537,7 @@
 	uerror("mkdirat", path);
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.mkdirat not available");
+    caml_invalid_argument("Netsys_posix.mkdirat not available");
 #endif
 }
 
@@ -551,7 +551,7 @@
 	uerror("renameat", oldpath);
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.renameat not available");
+    caml_invalid_argument("Netsys_posix.renameat not available");
 #endif
 }
 
@@ -561,14 +561,14 @@
 {
 #ifdef HAVE_AT
     int cv_flags;
-    cv_flags = convert_flag_list(flags, at_flags_table);
+    cv_flags = caml_convert_flag_list(flags, at_flags_table);
     cv_flags &= AT_SYMLINK_FOLLOW;  /* only allowed flag here */
     if (linkat(Int_val(olddirfd), String_val(oldpath),
 	       Int_val(newdirfd), String_val(newpath), cv_flags) == -1)
 	uerror("linkat", oldpath);
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.linkat not available");
+    caml_invalid_argument("Netsys_posix.linkat not available");
 #endif
 }
 
@@ -577,13 +577,13 @@
 {
 #ifdef HAVE_AT
     int cv_flags;
-    cv_flags = convert_flag_list(flags, at_flags_table);
+    cv_flags = caml_convert_flag_list(flags, at_flags_table);
     cv_flags &= AT_REMOVEDIR;  /* only allowed flag here */
     if (unlinkat(Int_val(dirfd), String_val(path), cv_flags) == -1)
 	uerror("unlinkat", path);
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.unlinkat not available");
+    caml_invalid_argument("Netsys_posix.unlinkat not available");
 #endif
 }
 
@@ -597,7 +597,7 @@
 	uerror("symlinkat", oldpath);
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.symlinkat not available");
+    caml_invalid_argument("Netsys_posix.symlinkat not available");
 #endif
 }
 
@@ -609,7 +609,7 @@
 	uerror("mkfifoat", path);
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.mkfifoat not available");
+    caml_invalid_argument("Netsys_posix.mkfifoat not available");
 #endif
 }
 
@@ -622,8 +622,8 @@
   len = readlinkat(Int_val(dirfd), String_val(path), buffer, sizeof(buffer)-1);
   if (len == -1) uerror("readlinkat", path);
   buffer[len] = '\0';
-  return copy_string(buffer);
+  return caml_copy_string(buffer);
 #else
-    invalid_argument("Netsys_posix.readlinkat not available");
+    caml_invalid_argument("Netsys_posix.readlinkat not available");
 #endif
 }
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c.h ocamlnet-4.1.9.patched/src/netsys/netsys_c.h
--- src/netsys/netsys_c.h	2021-03-24 16:20:14
+++ src/netsys/netsys_c.h	2026-05-29 06:32:02
@@ -69,6 +69,7 @@
 #include "caml/callback.h"
 #include "caml/bigarray.h"
 #include "caml/version.h"
+#include "caml/unixsupport.h"
 
 #ifndef Bytes_val
 #define Bytes_val(x) String_val(x)
@@ -103,7 +104,7 @@
 int caml_page_table_add(int kind, void * start, void * end);
 int caml_page_table_remove(int kind, void * start, void * end);
 
-#ifdef HAVE_NEW_MODIFY
+#if defined(HAVE_NEW_MODIFY) && OCAML_VERSION < 50000
 
 /* need full memory.h support */
 
@@ -171,25 +172,8 @@
 /* From unixsupport.h                                                 */
 /**********************************************************************/
 
-#define Nothing ((value) 0)
-
 #ifdef _WIN32
-#include "caml/unixsupport.h"
 #define netsysw32_win_alloc_handle win_alloc_handle
-#else
-
-/* POSIX */
-
-/* Since OCaml 3.10 there is unixsupport.h, and we could also include
-   this file.
-*/
-
-extern value unix_error_of_code (int errcode);
-extern void unix_error (int errcode, char * cmdname, value arg) Noreturn;
-extern void uerror (char * cmdname, value arg) Noreturn;
-
-#define DIR_Val(v) *((DIR **) &Field(v, 0))
-
 #endif
 
 /**********************************************************************/
@@ -231,7 +215,9 @@
 /* bigarrays                                                          */
 /**********************************************************************/
 
+#if !defined(OCAML_VERSION) || OCAML_VERSION < 50400
 extern int caml_ba_element_size[];
+#endif
 
 
 #endif
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_clock.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_clock.c
--- src/netsys/netsys_c_clock.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_clock.c	2026-05-29 06:31:44
@@ -23,10 +23,10 @@
 
     d = Double_val(Field(tspair,0));
     if (!isfinite(d) || d < 0 || d > LONG_MAX-1)
-	failwith("Netsys_posix: time value out of range");
+	caml_failwith("Netsys_posix: time value out of range");
     n = Long_val(Field(tspair,1));
     if (n < 0 || n > 999999999)
-	failwith("Netsys_posix: time value out of range");
+	caml_failwith("Netsys_posix: time value out of range");
     i = floor(d);
     r = floor((d - i) * 1E9);
     r = r + n;
@@ -44,7 +44,7 @@
 static value alloc_timespec_pair(double sec, long nsec) {
     CAMLparam0();
     CAMLlocal1(tsout);
-    tsout = alloc(2,0);
+    tsout = caml_alloc(2,0);
     Store_field(tsout, 0, caml_copy_double(sec));
     Store_field(tsout, 1, Val_long(nsec));
     CAMLreturn(tsout);
@@ -65,7 +65,7 @@
 	    *out = CLOCK_MONOTONIC;
 	    break;
 #else
-	    failwith("Netsys_posix: CLOCK_MONOTONIC is not supported");
+	    caml_failwith("Netsys_posix: CLOCK_MONOTONIC is not supported");
 #endif
 	}
     }
@@ -98,11 +98,11 @@
     tsout = alloc_timespec_pair(t_out.tv_sec, t_out.tv_nsec);
     Store_field(tsref, 0, tsout);
 
-    if (r == -1) unix_error(e, "nanosleep", Nothing);
+    if (r == -1) caml_unix_error(e, "nanosleep", Nothing);
    
     CAMLreturn(Val_unit);
 #else
-    invalid_argument("Netsys_posix.nanosleep not available");
+    caml_invalid_argument("Netsys_posix.nanosleep not available");
 #endif
 }
 
@@ -118,13 +118,13 @@
 
     clockid_val(clock, &c);
     r = clock_gettime(c, &ts);
-    if (r == -1) uerror("clock_gettime", Nothing);
+    if (r == -1) caml_uerror("clock_gettime", Nothing);
     
     tsout = alloc_timespec_pair(ts.tv_sec, ts.tv_nsec);
     
     CAMLreturn(tsout);
 #else
-    invalid_argument("Netsys_posix.clock_gettime not available");
+    caml_invalid_argument("Netsys_posix.clock_gettime not available");
 #endif
 }
 
@@ -141,11 +141,11 @@
     make_timespec(tspair, &ts);
 
     r = clock_settime(c, &ts);
-    if (r == -1) uerror("clock_settime", Nothing);
+    if (r == -1) caml_uerror("clock_settime", Nothing);
     
     CAMLreturn(Val_unit);
 #else
-    invalid_argument("Netsys_posix.clock_settime not available");
+    caml_invalid_argument("Netsys_posix.clock_settime not available");
 #endif
 }
 
@@ -162,13 +162,13 @@
     clockid_val(clock, &c);
 
     r = clock_getres(c, &ts);
-    if (r == -1) uerror("clock_getres", Nothing);
+    if (r == -1) caml_uerror("clock_getres", Nothing);
     
     tsout = alloc_timespec_pair(ts.tv_sec, ts.tv_nsec);
     
     CAMLreturn(tsout);
 #else
-    invalid_argument("Netsys_posix.clock_getres not available");
+    caml_invalid_argument("Netsys_posix.clock_getres not available");
 #endif
 }
 
@@ -182,7 +182,7 @@
     char *s;
 
     r = clock_getcpuclockid(Long_val(pid), &c);
-    if (r != 0) unix_error(r, "clock_getcpuclockid", Nothing);
+    if (r != 0) caml_unix_error(r, "clock_getcpuclockid", Nothing);
 
     v = caml_alloc_string(sizeof(clockid_t));
     s = String_val(v);
@@ -191,7 +191,7 @@
 
     CAMLreturn(v);
 #else
-    invalid_argument("Netsys_posix.clock_getcpuclockid not available");
+    caml_invalid_argument("Netsys_posix.clock_getcpuclockid not available");
 #endif
 }
 
@@ -263,7 +263,7 @@
 	    sev.sigev_value.sival_ptr = ne;
 	    break;
 #else
-	    failwith("Netsys_posix.timer_create: unsupported type of timer");
+	    caml_failwith("Netsys_posix.timer_create: unsupported type of timer");
 #endif
 #endif
 	}
@@ -280,7 +280,7 @@
 	    sev.sigev_value.sival_ptr = ne;
 	    break;
 #else
-	    failwith("Netsys_posix.timer_create: unsupported type of timer");
+	    caml_failwith("Netsys_posix.timer_create: unsupported type of timer");
 #endif
 	case 1:
 	    /* TEXP_SIGNAL */
@@ -294,7 +294,7 @@
     switch (tcase) {
     case 0:
 	code = timer_create(c, &sev, &tm);
-	if (code == -1) uerror("timer_create", Nothing);
+	if (code == -1) caml_uerror("timer_create", Nothing);
 	v = caml_alloc_string(sizeof(timer_t));
 	memcpy(Bytes_val(v), (char *) &tm, sizeof(timer_t));
 	v_timer = caml_alloc(1, 0);
@@ -313,7 +313,7 @@
     Store_field(v, 1, v_event);
     CAMLreturn(v);
 #else
-    invalid_argument("Netsys_posix.timer_create not available");
+    caml_invalid_argument("Netsys_posix.timer_create not available");
 #endif
 }
 
@@ -346,7 +346,7 @@
 			     Bool_val(abstime) ? TIMER_ABSTIME : 0,
 			     &it,
 			     NULL);
-	if (code == -1) uerror("timer_settime", Nothing);
+	if (code == -1) caml_uerror("timer_settime", Nothing);
 	break;
 #ifdef HAVE_TIMERFD
     case 1:
@@ -356,14 +356,14 @@
 			       Bool_val(abstime) ? TFD_TIMER_ABSTIME : 0,
 			       &it,
 			       NULL);
-	if (code == -1) uerror("timerfd_settime", Nothing);
+	if (code == -1) caml_uerror("timerfd_settime", Nothing);
 	break;
 #endif
     };
 
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.timer_settime not available");
+    caml_invalid_argument("Netsys_posix.timer_settime not available");
 #endif
 }
 
@@ -382,14 +382,14 @@
 	/* POSIX timer */
 	extract_timer(Field(Field(timer, 0), 0), &tm);
 	code = timer_gettime(tm, &it);
-	if (code == -1) uerror("timer_gettime", Nothing);
+	if (code == -1) caml_uerror("timer_gettime", Nothing);
 	break;
 #ifdef HAVE_TIMERFD
     case 1:
 	/* TIMERFD */
 	fd = Int_val(Field(Field(timer, 0), 0));
 	code = timerfd_gettime(fd, &it);
-	if (code == -1) uerror("timerfd_gettime", Nothing);
+	if (code == -1) caml_uerror("timerfd_gettime", Nothing);
 	break;
 #endif
     };
@@ -398,7 +398,7 @@
 			    it.it_value.tv_nsec);
     return r;
 #else
-    invalid_argument("Netsys_posix.timer_gettime not available");
+    caml_invalid_argument("Netsys_posix.timer_gettime not available");
 #endif
 }
 
@@ -413,7 +413,7 @@
 	/* POSIX timer */
 	extract_timer(Field(Field(timer, 0), 0), &tm);
 	code = timer_delete(tm);
-	if (code == -1) uerror("timer_delete", Nothing);
+	if (code == -1) caml_uerror("timer_delete", Nothing);
 	break;
 #ifdef HAVE_TIMERFD
     case 1:
@@ -424,7 +424,7 @@
     }
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.timer_delete not available");
+    caml_invalid_argument("Netsys_posix.timer_delete not available");
 #endif
 }
 
@@ -435,9 +435,9 @@
 	return Field(timer,1);
     }
     else {
-	failwith("Netsys_posix.timer_event: timer is not connected with event");
+	caml_failwith("Netsys_posix.timer_event: timer is not connected with event");
     }
 #else
-    invalid_argument("Netsys_posix.timer_delete not available");
+    caml_invalid_argument("Netsys_posix.timer_delete not available");
 #endif
 }
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_event.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_event.c
--- src/netsys/netsys_c_event.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_event.c	2026-05-29 06:31:44
@@ -187,24 +187,24 @@
     p->allow_user_add = Bool_val(allow_user_add);
 #ifdef HAVE_PTHREAD
     x = pthread_mutex_init(&(p->mutex), NULL);
-    if (x != 0) unix_error(x, "pthread_mutex_init", Nothing);
+    if (x != 0) caml_unix_error(x, "pthread_mutex_init", Nothing);
 #endif
 
 #ifdef HAVE_EVENTFD
     p->type = NE_EVENTFD;
     x = eventfd(0, 0);
-    if (x == -1) uerror("eventfd", Nothing);
+    if (x == -1) caml_uerror("eventfd", Nothing);
     p->fd1 = x;
     x = fcntl(p->fd1, F_SETFD, FD_CLOEXEC);
     if (x == -1) {
 	e = errno;
 	close(p->fd1);
-	unix_error(e, "fcntl", Nothing);
+	caml_unix_error(e, "fcntl", Nothing);
     }
 #else
     p->type = NE_PIPE;
     x = pipe(pipefd);
-    if (x == -1) uerror("pipe", Nothing);
+    if (x == -1) caml_uerror("pipe", Nothing);
     p->fd1 = pipefd[0];
     p->fd2 = pipefd[1];
     x = fcntl(p->fd1, F_SETFD, FD_CLOEXEC);
@@ -212,19 +212,19 @@
 	e = errno;
 	close(p->fd1);
 	close(p->fd2);
-	unix_error(e, "fcntl", Nothing);
+	caml_unix_error(e, "fcntl", Nothing);
     }
     x = fcntl(p->fd2, F_SETFD, FD_CLOEXEC);
     if (x == -1) {
 	e = errno;
 	close(p->fd1);
 	close(p->fd2);
-	unix_error(e, "fcntl", Nothing);
+	caml_unix_error(e, "fcntl", Nothing);
     }
 #endif
     return r;
 #else
-    invalid_argument("Netsys_posix.create_event not available");
+    caml_invalid_arggument("Netsys_posix.create_event not available");
 #endif
 }
 
@@ -246,13 +246,13 @@
 
     p->type = NE_TIMERFD;
     x = timerfd_create(clockid, 0);
-    if (x == -1) uerror("timerfd_create", Nothing);
+    if (x == -1) caml_uerror("timerfd_create", Nothing);
     p->fd1 = x;
     x = fcntl(p->fd1, F_SETFD, FD_CLOEXEC);
     if (x == -1) {
 	e = errno;
 	close(p->fd1);
-	unix_error(e, "fcntl", Nothing);
+	caml_unix_error(e, "fcntl", Nothing);
     }
     return r;
 }
@@ -268,17 +268,17 @@
     ne = *(Not_event_val(nev));
 
     if (ne->fd1 == -1) 
-	failwith("Netsys_posix.set_nonblock_event: already destroyed");
+	caml_failwith("Netsys_posix.set_nonblock_event: already destroyed");
     
     x = fcntl(ne->fd1, F_GETFL, 0);
-    if (x == -1) uerror("fcntl", Nothing);
+    if (x == -1) caml_uerror("fcntl", Nothing);
 
     x = fcntl(ne->fd1, F_SETFL, x | O_NONBLOCK);
-    if (x == -1) uerror("fcntl", Nothing);
+    if (x == -1) caml_uerror("fcntl", Nothing);
 
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.set_nonblock_event not available");
+    caml_invalid_argument("Netsys_posix.set_nonblock_event not available");
 #endif
 }
 
@@ -290,10 +290,10 @@
     int fd, code;
     ne = *(Not_event_val(nev));
     if (ne->fd1 == -1) 
-	failwith("Netsys_posix.get_event_fd_nodup: already destroyed");
+	caml_failwith("Netsys_posix.get_event_fd_nodup: already destroyed");
     return Val_int(ne->fd1);
 #else
-    invalid_argument("Netsys_posix.get_event_fd not available");
+    caml_invalid_argument("Netsys_posix.get_event_fd not available");
 #endif
 }
 
@@ -306,11 +306,11 @@
     int fd;
     ne = *(Not_event_val(nev));
     if (ne->fd1 == -1) 
-	failwith("Netsys_posix.get_event_fd: already destroyed");
+	caml_failwith("Netsys_posix.get_event_fd: already destroyed");
     fd = ne->fd1;
     return fd;
 #else
-    invalid_argument("Netsys_posix.get_event_fd not available");
+    caml_invalid_argument("Netsys_posix.get_event_fd not available");
 #endif
 }
 
@@ -350,15 +350,15 @@
     CAMLparam1(nev);
     ne = *(Not_event_val(nev));
     if (ne->fd1 == -1) 
-	failwith("Netsys_posix.set_event: already destroyed");
+	caml_failwith("Netsys_posix.set_event: already destroyed");
     if (!ne->allow_user_add)
-	failwith("Netsys_posix.set_event: not allowed for this type of event");
+	caml_failwith("Netsys_posix.set_event: not allowed for this type of event");
     caml_enter_blocking_section();
     netsys_not_event_signal(ne);
     caml_leave_blocking_section();
     CAMLreturn(Val_unit);
 #else
-    invalid_argument("Netsys_posix.set_event not available");
+    caml_invalid_argument("Netsys_posix.set_event not available");
 #endif
 }
 
@@ -373,7 +373,7 @@
     ne = *(Not_event_val(nev));
     
     if (ne->fd1 == -1) 
-	failwith("Netsys_posix.wait_event: already destroyed");
+	caml_failwith("Netsys_posix.wait_event: already destroyed");
 
     caml_enter_blocking_section();
     p.fd = ne->fd1;
@@ -383,10 +383,10 @@
     e = errno;
     caml_leave_blocking_section();
 
-    if (code == -1) unix_error(e, "poll", Nothing);
+    if (code == -1) caml_unix_error(e, "poll", Nothing);
     CAMLreturn(Val_unit);
 #else
-    invalid_argument("Netsys_posix.wait_event not available");
+    caml_invalid_argument("Netsys_posix.wait_event not available");
 #endif
 }
 
@@ -402,7 +402,7 @@
     ne = *(Not_event_val(nev));
     
     if (ne->fd1 == -1) 
-	failwith("Netsys_posix.consume_event: already destroyed");
+	caml_failwith("Netsys_posix.consume_event: already destroyed");
 
     caml_enter_blocking_section();
 
@@ -426,8 +426,8 @@
 
     caml_leave_blocking_section();
 
-    if (code == -1) unix_error(e, "read", Nothing);
-    if (!ok) unix_error(EINVAL, "read (result invalid)", Nothing);
+    if (code == -1) caml_unix_error(e, "read", Nothing);
+    if (!ok) caml_unix_error(EINVAL, "read (result invalid)", Nothing);
 
     ne->state = 0;
     /* No need to block signals, or to use the mutex. The next signaller
@@ -436,6 +436,6 @@
 
     CAMLreturn(Val_unit);
 #else
-    invalid_argument("Netsys_posix.wait_event not available");
+    caml_invalid_argument("Netsys_posix.wait_event not available");
 #endif
 }
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_fadvise.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_fadvise.c
--- src/netsys/netsys_c_fadvise.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_fadvise.c	2026-05-29 06:32:10
@@ -35,7 +35,7 @@
     case 3: case 9: adv_int = POSIX_FADV_NOREUSE; break;
     case 4: case 10: adv_int = POSIX_FADV_WILLNEED; break;
     case 5: case 11: adv_int = POSIX_FADV_DONTNEED; break;
-    default: invalid_argument("Netsys.fadvise");
+    default: caml_invalid_argument("Netsys.fadvise");
     };
 
     start_int = Int64_val(start);
@@ -54,7 +54,7 @@
 	uerror("posix_fadvise64", Nothing);
     return Val_unit;
 #else
-    invalid_argument("Netsys.fadvise not available");
+    caml_invalid_argument("Netsys.fadvise not available");
 #endif
 }
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_fallocate.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_fallocate.c
--- src/netsys/netsys_c_fallocate.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_fallocate.c	2026-05-29 06:31:44
@@ -28,9 +28,9 @@
     len_int = Int64_val(len);
 
     if ( ((int64_t) ((off_t) start_int)) != start_int )
-	failwith("Netsys.fadvise: large files not supported on this OS");
+	caml_failwith("Netsys.fadvise: large files not supported on this OS");
     if ( ((int64_t) ((off_t) len_int)) != len_int )
-	failwith("Netsys.fadvise: large files not supported on this OS");
+	caml_failwith("Netsys.fadvise: large files not supported on this OS");
 
     start_off = start_int;
     len_off = len_int;
@@ -38,10 +38,10 @@
     r = posix_fallocate(Int_val(fd), start_off, len_off);
     /* does not set errno! */
     if (r != 0) 
-	unix_error(r, "posix_fallocate64", Nothing);
+	caml_unix_error(r, "posix_fallocate64", Nothing);
     return Val_unit;
 #else
-    invalid_argument("Netsys.fallocate not available");
+    caml_invalid_argument("Netsys.fallocate not available");
 #endif
 }
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_ioprio.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_ioprio.c
--- src/netsys/netsys_c_ioprio.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_ioprio.c	2026-05-29 06:31:44
@@ -89,11 +89,11 @@
 	ioprio = ioprio_get(IOPRIO_WHO_USER, Int_val(Field(target, 0)));
 	break;
     default:
-	failwith("netsys_ioprio_get: internal error");
+	caml_failwith("netsys_ioprio_get: internal error");
     }
 
     if (ioprio == -1)
-	uerror("ioprio_get", Nothing);
+	caml_uerror("ioprio_get", Nothing);
 
     ioprio_class = ioprio >> IOPRIO_CLASS_SHIFT;
     ioprio_data = ioprio & IOPRIO_PRIO_MASK;
@@ -114,14 +114,14 @@
 	result = Val_long(1);
 	break;
     default:
-	failwith("netsys_ioprio_get: Unexpected result");
+	caml_failwith("netsys_ioprio_get: Unexpected result");
     }
     
     return result;
 
 #else
     /* not ioprio_supported: */
-    unix_error(ENOSYS, "ioprio_get", Nothing);
+    caml_unix_error(ENOSYS, "ioprio_get", Nothing);
 #endif
     /* ioprio_supported */
 }
@@ -145,7 +145,7 @@
 	    ioprio_data = Int_val(Field(ioprio_arg, 0));
 	    break;
 	default:
-	    failwith("netsys_ioprio_set: internal error");
+	    caml_failwith("netsys_ioprio_set: internal error");
 	}
     } else {
 	switch (Long_val(ioprio_arg)) {
@@ -159,7 +159,7 @@
 	    ioprio_data = 7;
 	    break;
 	default:
-	    failwith("netsys_ioprio_set: internal error");
+	    caml_failwith("netsys_ioprio_set: internal error");
 	}
     };
 
@@ -176,16 +176,16 @@
 	sysres = ioprio_set(IOPRIO_WHO_USER, Int_val(Field(target, 0)), ioprio);
 	break;
     default:
-	failwith("netsys_ioprio_set: internal error");
+	caml_failwith("netsys_ioprio_set: internal error");
     }
 
     if (sysres == -1)
-	uerror("ioprio_set", Nothing);
+	caml_uerror("ioprio_set", Nothing);
 
     return Val_unit;
 #else
     /* not ioprio_supported: */
-    unix_error(ENOSYS, "ioprio_set", Nothing);
+    caml_unix_error(ENOSYS, "ioprio_set", Nothing);
 #endif
     /* ioprio_supported */
 }
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_locale.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_locale.c
--- src/netsys/netsys_c_locale.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_locale.c	2026-05-29 06:31:44
@@ -39,28 +39,28 @@
 
     old_locale = setlocale(LC_ALL, NULL);
     if (old_locale == NULL)
-	failwith("Netsys_posix.query_locale: no locale support");
-    oldcopy_locale = stat_alloc(strlen(old_locale) + 1);
+	caml_failwith("Netsys_posix.query_locale: no locale support");
+    oldcopy_locale = caml_stat_alloc(strlen(old_locale) + 1);
     strcpy(oldcopy_locale, old_locale);
 
     new_locale = setlocale(LC_ALL, String_val(locale));
     if (new_locale == NULL) {
-	stat_free(oldcopy_locale);
-	failwith("Netsys_posix.query_locale: cannot set this locale");
+	caml_stat_free(oldcopy_locale);
+	caml_failwith("Netsys_posix.query_locale: cannot set this locale");
     }
     
     n = sizeof(locale_items_table) / sizeof(locale_items_table[0]);
-    s = alloc(n,0);
+    s = caml_alloc(n,0);
     for (k=0; k<n; k++) {
-	Store_field(s,k,copy_string(nl_langinfo(locale_items_table[k])));
+	Store_field(s,k,caml_copy_string(nl_langinfo(locale_items_table[k])));
     };
     
     setlocale(LC_ALL, oldcopy_locale);
-    stat_free(oldcopy_locale);
+    caml_stat_free(oldcopy_locale);
 
     CAMLreturn (s);
 #else
-    invalid_argument("Netsys_posix.query_locale not available");
+    caml_invalid_argument("Netsys_posix.query_locale not available");
 #endif
 }
 
